#include <math.h>
#include <stdlib.h>
#include "CException.h"
#include "ErrorCode.h"
#include "TriangleArea.h"

double triangleArea(double a, double b, double c)
{
  if (   (a <= 0.0)
      || (b <= 0.0)
      || (c <= 0.0)
      )
      Throw(NEGATIVE_SIDE);
       
  if (   (a <= fabs(b - c))
      || (a >= (b + c))
      )
      Throw(BAD_TRIANGLE);
          
  double p = (a + b + c) / 2.0;
  double result = sqrt(p * (p - a) * (p - b) * (p - c));
  return result;
}
